#include <stdlib.h>

#include "block.h"

void
append_block (BlockList *block_list, Block *block)
{
    block->prev = block_list->tail;

    if (block_list->head == NULL)
	block_list->head = block_list->tail = block;
    else
	block_list->tail = block_list->tail->next = block;
}

Block *
detach_block (BlockList *block_list)
{
    Block *block;

    if (block_list->head == NULL)
	return NULL;

    block = block_list->tail;
    block_list->tail = block_list->tail->prev;
    block->prev = NULL;

    if (block_list->tail == NULL)
	block_list->head = NULL;
    else
	block_list->tail->next = NULL;

    return block;
}

Block *
pop_block (BlockList *block_list)
{
    Block *block;

    if (block_list->head == NULL)
	return NULL;

    block = block_list->head;
    block->next = NULL;
    block_list->head = block_list->head->next;

    if (block_list->head == NULL)
	block_list->tail = NULL;
    else
	block_list->head->prev = NULL;

    return block;
}
