#ifndef BLOCK_H
#define BLOCK_H

#include "buffer.h"

/* 0...9 -> 0...9 */
#define B  10
#define EM 11
#define I  12
#define PL 13
#define S  14
#define TT 15
#define U  16
#define cr  17
#define cg  18
#define cb  19
#define cc  20
#define cm  21
#define cy  22
#define ck  23
#define cw  24

typedef struct _Block {
    struct _Block *prev, *next;
    Buffer *stack;
    unsigned int n_pop;
    char *text;
} Block;

typedef struct {
    Block *head;
    Block *tail;
} BlockList;

void   append_block (BlockList *block_list, Block *block);
Block *detach_block (BlockList *block_list);
Block *pop_block    (BlockList *block_list);

#endif
