#ifndef BUFFER_H
#define BUFFER_H

typedef struct {
    char *buffer;
    unsigned int length;
    int index;
} Buffer;

#define top_char(b) ((b)->buffer[(b)->index])
#define next_char(b) ((b)->buffer[(b)->index-1])
#define index(b, index) ((b)->buffer[index])
#define empty(b) ((b)->index == -1 ? 1 : 0)

Buffer *new_buffer   (int initial_size);
Buffer *buffer_dup   (Buffer *b);
void    free_buffer  (Buffer *b);
void    clear_buffer (Buffer *b);
void    push_char    (Buffer *b, int c);
int     pop_char     (Buffer *b);
void    remove_char  (Buffer *b, int i);
Buffer *intersect    (Buffer *a, Buffer *b);
void    add          (Buffer *a, Buffer *b);
void    subtract     (Buffer *a, Buffer *b);

#endif
