#ifndef STATE
#define STATE

typedef struct {
    unsigned int b : 1;
    unsigned int em : 1;
    unsigned int i : 1;
    unsigned int s : 1;
    unsigned int tt : 1;
    unsigned int u : 2;
    unsigned int size : 4;
    unsigned int color : 4;
} State;

#define RED           0
#define GREEN         1
#define BLUE          2
#define CYAN          3
#define MAGENTA       4
#define YELLOW        5
#define BLACK         6
#define WHITE         7
#define DEFAULT_COLOR 8

#define DEFAULT_SIZE  10

#define INITIAL_STATE {0, 0, 0, 0, 0, 0, DEFAULT_SIZE, DEFAULT_COLOR}
#define is_inital(state) ((state).b == 0 && (state).em == 0 && (state).i == 0	\
		       && (state).s == 0 && (state).tt == 0 && (state).u == 0	\
		       && (state).size == DEFAULT_SIZE && (state).color == DEFAULT_COLOR)
#define is_pl(state) ((state).b == 0 && (state).em == 0 && (state).i == 0       \
		      && (state).s == 0 && (state).tt == 0 && (state).u == 0)

#define xor(a, b) (((~(a)) & (b)) | ((a) & (~(b))))
#define xor_add_state(s0, s1) (xor (s0.b, s1.b) + xor (s0.em, s1.em) +	\
			       xor (s0.i, s1.i) + xor (s0.s, s1.s) +	\
			       xor (s0.i, s1.tt) + xor (s0.s, s1.u))

#define state_equals(s0, s1) (memcmp (&(s0), &(s1), sizeof (State)) == 0)

#define top_state(s) (s->state)
#define tt_set(s) (s->state.tt)

typedef struct _StateStack {
    struct _StateStack *next;
    State state;
} StateStack;

StateStack *push_state (StateStack *stack, State state);
StateStack *pop_state  (StateStack *stack);

#endif
