#include <stdlib.h>
#include <string.h>

#include "tagged_text.h"

void
free_text_list (TaggedText *text)
{
    TaggedText *next;

    if (text == NULL)
	return;

    next = text->next;
    free (text->text);
    free (text);

    free_text_list (next);
}

void
append_text (TaggedTextList *text_list, Buffer *buffer, State state)
{
    TaggedText *text = malloc (sizeof (TaggedText));
    
    text->next = NULL;
    text->prev = text_list->tail;
    text->text = strdup (buffer->buffer);
    text->state = state;

    if (text_list->head == NULL)
	text_list->head = text_list->tail = text;
    else
	text_list->tail = text_list->tail->next = text;
}
